#!/bin/sh
#
# CGI script for transmitting multiple files, with names received from
#   an http POST operation
#
# Written by Dave Dykstra <dwd@bell-labs.com> 12 Feb 1997
#
exec 2>&1
BOUNDARY="----"
error()
{
ME=`/bin/basename $0`
cat <<!END!
X-Multiget-Error: $*
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>
Error from $ME
</TITLE>
<BODY>
<H1>
Error from $ME:
</H1>
<H3>
<P>
$*
</H3>
!END!

exit

}

if [ -z "${CONTENT_LENGTH:-}" ]
then
    error "No CONTENT_LENGTH environment variable, must be invoked from a CGI POST"
fi

case ${QUERY_STRING:-} in
    "") PREFIX="";;
    */) PREFIX=$QUERY_STRING;;
    *) PREFIX=$QUERY_STRING/;;
esac

echo "Content-Type: application/x-multiget\n"

# this awk script is to avoid reading more lines from stdin
#  than are available; I know no easier way to do that in sh
# it also removes carriage returns in file names
awk "BEGIN{len = $CONTENT_LENGTH}"'
    {l = length($0)
    if (substr($0,l,1) == "\r") {printf("%s\n",substr($0,1,--l))} else {print}
    if ((len -= l+1) <= 0) exit}'| sed 's/\\/\\\\/' | while read N
do
    F=$PREFIX$N
    case "/$F/" in
	//*) error "file must be a relative pathname";;
	*/../*) error 'file may not contain ".." components';;
    esac

    if [ ! -r "$F" ]
    then
	error "cannot read \"$F\""
    fi

    if [ ! -f "$F" ]
    then
	error "$F is not a file"
    fi

    LENGTH=`ls -lL "$F"|awk '{print $5}'`
    echo "Content-Name: $N"
    echo "Content-Length: $LENGTH\n"
    cat "$F"
    echo
done
