/*
 * This program is intended to be installed setuid (and possibly setgid)
 * to be invoked from a CGI script to immediately check for an update to
 * an nsbd-registered package.
 * Written by Dave Dykstra <dwd@bell-labs.com> 4 March 1997.
 */

#ifndef NSBD
"You must define NSBD as a complete double-quoted path to nsbd program.";
#endif
#ifndef NSBDPATH
"You must define NSBDPATH as a complete double-quoted path to directory";
"that NSBD uses for its support files, typically $HOME/.nsbd";
#endif

#include <stdio.h>
#include <sys/wait.h>

main()
{
    char *package, *getenv();
    char nsbdpath[sizeof(NSBDPATH)+16];
    printf("Content-type: text/plain\n\n");
    fflush(stdout);

    package = getenv("QUERY_STRING");
    if ((package == NULL) || (*package == '\0')) {
	printf("ERROR: expected to be invoked as a CGI command with\n");
	printf("  a ? parameter of a registered package name\n");
	return(0);
    }
    nsbdpath[0] = '\0';
    strcat(nsbdpath, "nsbdpath=");
    strcat(nsbdpath, NSBDPATH);
    /* Need to fork and ignore error return codes or some HTTP servers
     *   will not show any output */
    if (fork() == 0) {
	close(2);
	dup(1);
	execle(NSBD, NSBD, nsbdpath, "-updateOnePackage", package, NULL, NULL);
	printf("could not exec %s\n", NSBD);
    } else {
	wait(NULL);
    }

    return(0);
}
